var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { createElement as _createElement } from "react";
import React, { useState } from 'react';
import { getClassName } from '@react-devui/utils';
import { DButton } from '../button';
import { usePrefixConfig, useTranslation } from '../root';
export function DFooter(props) {
    const { dClassNamePrefix, dAlign, dActions, dCancelProps, dOkProps, onCancelClick, onOkClick, onClose } = props, restProps = __rest(props, ["dClassNamePrefix", "dAlign", "dActions", "dCancelProps", "dOkProps", "onCancelClick", "onOkClick", "onClose"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const [t] = useTranslation();
    const [cancelLoading, setCancelLoading] = useState(false);
    const [okLoading, setOkLoading] = useState(false);
    const cancelProps = Object.assign(Object.assign({}, dCancelProps), { dLoading: (dCancelProps === null || dCancelProps === void 0 ? void 0 : dCancelProps.dLoading) || cancelLoading, onClick: () => {
            const shouldClose = onCancelClick === null || onCancelClick === void 0 ? void 0 : onCancelClick();
            if (shouldClose instanceof Promise) {
                setCancelLoading(true);
                shouldClose.then((val) => {
                    setCancelLoading(false);
                    if (val !== false) {
                        onClose === null || onClose === void 0 ? void 0 : onClose();
                    }
                });
            }
            else if (shouldClose !== false) {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        } });
    const okProps = Object.assign(Object.assign({}, dOkProps), { dLoading: (dOkProps === null || dOkProps === void 0 ? void 0 : dOkProps.dLoading) || okLoading, onClick: () => {
            const shouldClose = onOkClick === null || onOkClick === void 0 ? void 0 : onOkClick();
            if (shouldClose instanceof Promise) {
                setOkLoading(true);
                shouldClose.then((val) => {
                    setOkLoading(false);
                    if (val !== false) {
                        onClose === null || onClose === void 0 ? void 0 : onClose();
                    }
                });
            }
            else if (shouldClose !== false) {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        } });
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${prefix}__footer`, `${prefix}__footer--${dAlign}`) }, { children: React.Children.map(dActions, (action) => {
            var _a, _b, _c;
            return action === 'cancel' ? (_createElement(DButton, Object.assign({}, cancelProps, { key: "$$cancel", dType: (_a = cancelProps.dType) !== null && _a !== void 0 ? _a : 'secondary' }), (_b = cancelProps.children) !== null && _b !== void 0 ? _b : t('Footer', 'Cancel'))) : action === 'ok' ? (_createElement(DButton, Object.assign({}, okProps, { key: "$$ok" }), (_c = okProps.children) !== null && _c !== void 0 ? _c : t('Footer', 'OK'))) : (action);
        }) })));
}
