import type { DCloneHTMLElement } from '../../utils/types';
import type React from 'react';
export interface DPopupProps {
    children: (props: {
        renderTrigger: DCloneHTMLElement;
        renderPopup: DCloneHTMLElement;
    }) => JSX.Element | null;
    dVisible: boolean;
    dTrigger: 'hover' | 'click';
    dMouseEnterDelay?: number;
    dMouseLeaveDelay?: number;
    dUpdatePosition: {
        fn: () => void;
        triggerRef: React.RefObject<HTMLElement>;
        popupRef: React.RefObject<HTMLElement>;
        extraScrollRefs: (React.RefObject<HTMLElement> | undefined)[];
    };
    onVisibleChange: (visible: boolean) => void;
}
export declare function DPopup(props: DPopupProps): JSX.Element | null;
