import { get } from 'lodash';
import { useContextRequired } from '../../../hooks';
import { DConfigContext } from '../contex';
export function useTranslation() {
    const { lang, resources } = useContextRequired(DConfigContext).i18n;
    return [
        (...keys) => {
            if (keys.length === 1) {
                keys = ['Common', keys[0]];
            }
            keys.unshift(lang);
            return get(resources, keys, keys.join('.'));
        },
        lang,
    ];
}
